<?php

Yii::import('application.modules.core_models.models._base.BaseModel');

/**
 * This is the model base class for the table "country".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "Country".
 *
 * Columns in table "country" available as properties of the model,
 * followed by relations of table "country" available as properties of the model.
 *
 * @property integer $id
 * @property string $name
 * @property string $code
 * @property string $phone_prefix
 * @property integer $default_localization_id
 *
 * @property Account[] $accounts
 * @property Localization $defaultLocalization
 * @property Practice[] $practices
 * @property State[] $states
 */
abstract class BaseCountry extends BaseModel
{

    public static function model($className = __CLASS__)
    {
        return parent::model($className);
    }

    public function tableName()
    {
        return 'country';
    }

    public static function label($n = 1)
    {
        return Yii::t('app', 'Country|Countries', $n);
    }

    public static function representingColumn()
    {
        return 'name';
    }

    public function rules()
    {
        return array(
            array('name, code', 'required'),
            array('default_localization_id', 'numerical', 'integerOnly' => true),
            array('name', 'length', 'max' => 50),
            array('code', 'length', 'max' => 2),
            array('phone_prefix', 'length', 'max' => 6),
            array('default_localization_id', 'default', 'setOnEmpty' => true, 'value' => null),
            array('id, name, code, default_localization_id', 'safe', 'on' => 'search'),
        );
    }

    public function relations()
    {
        return array(
            'accounts' => array(self::HAS_MANY, 'Account', 'country_id'),
            'defaultLocalization' => array(self::BELONGS_TO, 'Localization', 'default_localization_id'),
            'practices' => array(self::HAS_MANY, 'Practice', 'country_id'),
            'states' => array(self::HAS_MANY, 'State', 'country_id'),
        );
    }

    public function pivotModels()
    {
        return array(
        );
    }

    public function attributeLabels()
    {
        return array(
            'id' => Yii::t('app', 'ID'),
            'name' => Yii::t('app', 'Name'),
            'code' => Yii::t('app', 'Code'),
            'phone_prefix' => Yii::t('app', 'Phone Prefix'),
            'default_localization_id' => null,
            'accounts' => null,
            'defaultLocalization' => null,
            'practices' => null,
            'states' => null,
        );
    }

    public function search()
    {
        $criteria = new CDbCriteria;

        $criteria->compare('id', $this->id);
        $criteria->compare('name', $this->name, true);
        $criteria->compare('code', $this->code, true);
        $criteria->compare('default_localization_id', $this->default_localization_id);

        return new CActiveDataProvider($this, array(
            'criteria' => $criteria,
        ));
    }

}
